package com.wyattjmiller.repositories

import com.wyattjmiller.data.DatabaseManager
import com.wyattjmiller.data.DbRecipeTable
import com.wyattjmiller.entities.Recipe
import org.ktorm.dsl.eq
import org.ktorm.entity.*

class RecipeDao : RecipeRepository {
    private val db = DatabaseManager()

    override fun getAllRecipies() : List<Recipe> {
        return db.database
            .sequenceOf(DbRecipeTable)
            .toList()
            .map { Recipe(it.id, it.name, it.desc, it.ingredients) }
    }

    override fun getRecipe(id: Int) : Recipe {
        return db.database
            .sequenceOf(DbRecipeTable)
            .firstOrNull { it.id eq id }
            .let { Recipe(it!!.id, it.name, it.desc, it.ingredients) }
    }

    override fun createRecipe(recipe: Recipe) {
        TODO("Not yet implemented")
    }

    override fun updateRecipe(id: Int, recipe: Recipe): Boolean {
        TODO("Not yet implemented")
    }

    override fun deleteRecipe(id: Int) {
        TODO("Not yet implemented")
    }
}